local addonName, addon = ...


addon.groupieLocaleTable = {
    ["zhCN"] = "Chinese",
    ["zhTW"] = "Chinese",
    ["enGB"] = "English",
    ["enUS"] = "English",
    ["frFR"] = "French",
    ["deDE"] = "German",
    ["itIT"] = "Italian",
    ["koKR"] = "Korean",
    ["ptBR"] = "Portuguese",
    ["ruRU"] = "Russian",
    ["esES"] = "Spanish",
    ["esMX"] = "Spanish",
}

--For now, this only supports English, but implemented such that localization would be easy in the future
--https://en.wikipedia.org/wiki/List_of_ISO_639-2_codes Language Codes
--https://en.wikipedia.org/wiki/ISO_3166-2 Country Codes
addon.groupieUnflippedLanguagePatterns = {
    ["Chinese"]    = "chinese zho chi zh",
    ["English"]    = "english eng en",
    ["French"]     = "french fra fr",
    ["German"]     = "german deu ger de",
    ["Italian"]    = "italian ita it",
    ["Korean"]     = "korean kor ko",
    ["Portuguese"] = "portuguese por pt br",
    ["Russian"]    = "russian rus ru",
    ["Spanish"]    = "spanish spa es",
}

addon.groupieLangList = {
    [1] = "Chinese",
    [2] = "English",
    [3] = "French",
    [4] = "German",
    [5] = "Italian",
    [6] = "Korean",
    [7] = "Portuguese",
    [8] = "Russian",
    [9] = "Spanish",
}

addon.groupieRoleTable = {
    [1] = "Tank",
    [2] = "Healer",
    [3] = "Ranged DPS",
    [4] = "Melee DPS"
}

addon.groupieClassRoleTable = {
    ["Death Knight"] = {
        ["Blood"] = { [1] = "Tank" },
        ["Frost"] = { [1] = "Tank", [4] = "Melee DPS" },
        ["Unholy"] = { [4] = "Melee DPS" }
    },
    ["Druid"] = {
        ["Balance"] = { [3] = "Ranged DPS" },
        ["Feral Combat"] = { [1] = "Tank", [4] = "Melee DPS" },
        ["Restoration"] = { [2] = "Healer" }
    },
    ["Hunter"] = {
        ["Beast Mastery"] = { [3] = "Ranged DPS" },
        ["Marksmanship"] = { [3] = "Ranged DPS" },
        ["Survival"] = { [3] = "Ranged DPS" }
    },
    ["Mage"] = {
        ["Arcane"] = { [3] = "Ranged DPS" },
        ["Fire"] = { [3] = "Ranged DPS" },
        ["Frost"] = { [3] = "Ranged DPS" }
    },
    ["Paladin"] = {
        ["Holy"] = { [2] = "Healer" },
        ["Protection"] = { [1] = "Tank" },
        ["Retribution"] = { [4] = "Melee DPS" }
    },
    ["Priest"] = {
        ["Discipline"] = { [2] = "Healer" },
        ["Holy"] = { [2] = "Healer" },
        ["Shadow"] = { [3] = "Ranged DPS" }
    },
    ["Rogue"] = {
        ["Assassination"] = { [4] = "Melee DPS" },
        ["Combat"] = { [4] = "Melee DPS" },
        ["Subtlety"] = { [4] = "Melee DPS" }
    },
    ["Shaman"] = {
        ["Elemental"] = { [3] = "Ranged DPS" },
        ["Enhancement"] = { [4] = "Melee DPS" },
        ["Restoration"] = { [2] = "Healer" }
    },
    ["Warlock"] = {
        ["Affliction"] = { [3] = "Ranged DPS" },
        ["Demonology"] = { [3] = "Ranged DPS" },
        ["Destruction"] = { [3] = "Ranged DPS" }
    },
    ["Warrior"] = {
        ["Arms"] = { [4] = "Melee DPS" },
        ["Fury"] = { [4] = "Melee DPS" },
        ["Protection"] = { [1] = "Tank" }
    }
}

addon.groupieInstanceTypes = {
    "Wrath of the Lich King Heroic Raids - 25",
    "Wrath of the Lich King Heroic Raids - 10",
    "Wrath of the Lich King Raids - 25",
    "Wrath of the Lich King Raids - 10",
    "Wrath of the Lich King Heroic Dungeons",
    "Wrath of the Lich King Dungeons",
    "The Burning Crusade Raids",
    "The Burning Crusade Heroic Dungeons",
    "The Burning Crusade Dungeons",
    "Classic Raids",
    "Classic Dungeons",
}
--0 - Heroic
--1 - 10 Normal
--2 - 25 Normal
--3 - Heroic 10
--4 - Heroic 25
addon.groupieVersionPatterns = {
    ["h"] = 0,
    ["hc"] = 0,
    ["heroic"] = 0,
    ["10"] = 1,
    ["n10"] = 1,
    ["10n"] = 1,
    ["25"] = 2,
    ["n25"] = 2,
    ["25n"] = 2,
    ["h10"] = 3,
    ["10h"] = 3,
    ["h25"] = 4,
    ["25h"] = 4
}

--0 - Generic group
--1 - Looking for Tank
--2 - Looking for Healer
--3 - Looking for DPS
--4 - LFG
--5 - boost runs
addon.groupieLFPatterns = {
    ["group"] = 0,
    ["lf"] = 0,
    ["lfm"] = 0,
    ["run"] = 0,
    ["runs"] = 0,
    ["running"] = 0,

    ["lftank"] = 1,
    ["lftanks"] = 1,
    ["tank"] = 1,
    ["tanks"] = 1,

    ["lfheal"] = 2,
    ["lfhealer"] = 2,
    ["lfheals"] = 2,
    ["lfhealers"] = 2,
    ["heal"] = 2,
    ["heals"] = 2,
    ["healer"] = 2,
    ["healers"] = 2,

    ["lfdps"] = 3,
    ["dps"] = 3,
    ["melee"] = 3,
    ["ranged"] = 3,
    ["lfmelee"] = 3,
    ["lfranged"] = 3,

    ["lfg"] = 4,

    ["boost"] = 5,
    ["boosts"] = 5,
    ["boosting"] = 5,
    ["wts"] = 5,
}

addon.groupieUnflippedLootPatterns = {
    ["Ticket"] = "ticket",
    ["GDKP"] = "gdkp bid buyer",
    ["SoftRes"] = "2sr 1sr sr softres softreserve soft",
    ["MS > OS"] = "msos",
    ["Other"] = "afk boost boosting boosts exp mob mobs recruit recruiting recruits roster selling wts xp"
}

addon.lootTypeColors = {
    ["Ticket"] = "FFC107",
    ["GDKP"] = "4CAF50",
    ["SoftRes"] = "9C27B0",
    ["MS > OS"] = "2196F3",
    ["Other"] = "FFFFFF",
    ["PVP"] = "F44336",
}

addon.classColors = {
    ["Death Knight"] = "C41F3B",
    ["Druid"] = "FF7D0A",
    ["Hunter"] = "ABD473",
    ["Mage"] = "69CCF0",
    ["Monk"] = "00FF96",
    ["Paladin"] = "F58CBA",
    ["Priest"] = "FFFFFF",
    ["Rogue"] = "FFF569",
    ["Shaman"] = "0070DE",
    ["Warlock"] = "9482C9",
    ["Warrior"] = "C79C6E",
}

addon.multiWingInstances = { "Dire Maul - Full Clear", "Maraudon - Full Clear", "Scarlet Monastery - Full Clear" }

addon.edgeCasePatterns = { "mt", "os", "up", "dk", "eye" }

--instanceVersions[instance] = {{size, isHeroic}, ...}
addon.instanceVersions = {
    ["Ragefire Chasm"]                 = { { 5, false } },
    ["Wailing Caverns"]                = { { 5, false } },
    ["The Deadmines"]                  = { { 5, false } },
    ["Shadowfang Keep"]                = { { 5, false } },
    ["The Stockade"]                   = { { 5, false } },
    ["Blackfathom Deeps"]              = { { 5, false } },
    ["Gnomeregan"]                     = { { 5, false } },
    ["Razorfen Kraul"]                 = { { 5, false } },
    ["Scarlet Monastery - Full Clear"] = { { 5, false } },
    ["Scarlet Monastery - Graveyard"]  = { { 5, false } },
    ["Scarlet Monastery - Library"]    = { { 5, false } },
    ["Scarlet Monastery - Armory"]     = { { 5, false } },
    ["Scarlet Monastery - Cathedral"]  = { { 5, false } },
    ["Razorfen Downs"]                 = { { 5, false } },
    ["Uldaman"]                        = { { 5, false } },
    ["Zul'Farrak"]                     = { { 5, false } },
    ["Maraudon - Full Clear"]          = { { 5, false } },
    ["Maraudon - Princess"]            = { { 5, false } },
    ["Maraudon - Purple"]              = { { 5, false } },
    ["Maraudon - Orange"]              = { { 5, false } },
    ["The Temple of Atal'Hakkar"]      = { { 5, false } },
    ["Blackrock Depths"]               = { { 5, false } },
    ["Dire Maul - Full Clear"]         = { { 5, false } },
    ["Dire Maul - East Wing"]          = { { 5, false } },
    ["Dire Maul - North Wing"]         = { { 5, false } },
    ["Dire Maul - West Wing"]          = { { 5, false } },
    ["Lower Blackrock Spire"]          = { { 5, false } },
    ["Stratholme"]                     = { { 5, false } },
    ["Scholomance"]                    = { { 5, false } },

    ["Upper Blackrock Spire"] = { { 10, false } },
    ["Zul'Gurub"]             = { { 20, false } },
    ["Ruins of Ahn'Qiraj"]    = { { 20, false } },
    ["Onyxia's Lair"]         = { { 40, false } },
    ["Molten Core"]           = { { 40, false } },
    ["Blackwing Lair"]        = { { 40, false } },
    ["Temple of Ahn'Qiraj"]   = { { 40, false } },
    --["Naxxramas"]             = { { 40, false } },

    ["Hellfire Ramparts"]       = { { 5, false }, { 5, true } },
    ["The Blood Furnace"]       = { { 5, false }, { 5, true } },
    ["The Slave Pens"]          = { { 5, false }, { 5, true } },
    ["The Underbog"]            = { { 5, false }, { 5, true } },
    ["Mana-Tombs"]              = { { 5, false }, { 5, true } },
    ["Auchenai Crypts"]         = { { 5, false }, { 5, true } },
    ["Sethekk Halls"]           = { { 5, false }, { 5, true } },
    ["Old Hillsbrad Foothills"] = { { 5, false }, { 5, true } },
    ["Shadow Labyrinth"]        = { { 5, false }, { 5, true } },
    ["The Mechanar"]            = { { 5, false }, { 5, true } },
    ["The Shattered Halls"]     = { { 5, false }, { 5, true } },
    ["The Steamvault"]          = { { 5, false }, { 5, true } },
    ["The Botanica"]            = { { 5, false }, { 5, true } },
    ["The Arcatraz"]            = { { 5, false }, { 5, true } },
    ["The Black Morass"]        = { { 5, false }, { 5, true } },
    ["Magisters' Terrace"]      = { { 5, false }, { 5, true } },

    ["Karazhan"]             = { { 10, false } },
    ["Zul'Aman"]             = { { 10, false } },
    ["Gruul's Lair"]         = { { 25, false } },
    ["Magtheridon's Lair"]   = { { 25, false } },
    ["Serpentshrine Cavern"] = { { 25, false } },
    ["Tempest Keep"]         = { { 25, false } },
    ["Hyjal Summit"]         = { { 25, false } },
    ["Black Temple"]         = { { 25, false } },
    ["Sunwell Plateau"]      = { { 25, false } },

    ["Utgarde Keep"]               = { { 5, false }, { 5, true } },
    ["The Nexus"]                  = { { 5, false }, { 5, true } },
    ["Ajzol-Nerub"]                = { { 5, false }, { 5, true } },
    ["Ahn'kahet: The Old Kingdom"] = { { 5, false }, { 5, true } },
    ["Drak'Tharon Keep"]           = { { 5, false }, { 5, true } },
    ["The Violet Hold"]            = { { 5, false }, { 5, true } },
    ["Gundrak"]                    = { { 5, false }, { 5, true } },
    ["Halls of Stone"]             = { { 5, false }, { 5, true } },
    ["The Culling of Stratholme"]  = { { 5, false }, { 5, true } },
    ["Halls of Lightning"]         = { { 5, false }, { 5, true } },
    ["Utgarde Pinnacle"]           = { { 5, false }, { 5, true } },
    ["The Oculus"]                 = { { 5, false }, { 5, true } },
    ["Trial of the Champion"]      = { { 5, false }, { 5, true } },
    ["The Forge of Souls"]         = { { 5, false }, { 5, true } },
    ["Pit of Saron"]               = { { 5, false }, { 5, true } },
    ["Halls of Reflection"]        = { { 5, false }, { 5, true } },

    ["Naxxramas"]            = { { 10, false }, { 25, false } },
    ["The Obsidian Sanctum"] = { { 10, false }, { 25, false } },
    ["Vault of Archavon"]    = { { 10, false }, { 25, false } },
    ["The Eye of Eternity"]  = { { 10, false }, { 25, false } },
    --["Onyxia's Lair"]        = { { 10, false }, { 25, false } },
    ["Ulduar"]               = { { 10, false }, { 25, false } },

    ["Trial of the Crusader"]       = { { 10, false }, { 25, false }, { 10, true }, { 25, true } },
    ["Icecrown Citadel"]            = { { 10, false }, { 25, false }, { 10, true }, { 25, true } },
    ["The Ruby Sanctum"]            = { { 10, false }, { 25, false }, { 10, true }, { 25, true } },
    ["Trial of the Grand Crusader"] = { { 10, true }, { 25, true } }
}

--Instance IDs from : https://wowpedia.fandom.com/wiki/InstanceID
addon.groupieInstanceData = {
    ["Heroic The Ruby Sanctum - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Raids - 25", InstanceID = 724, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3550, Icon = "RS.tga" },
    ["Heroic Icecrown Citadel - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Raids - 25", InstanceID = 631, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3540, Icon = "ICC.tga" },
    ["Heroic Trial of the Grand Crusader - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Raids - 25", InstanceID = 649, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3530, Icon = "TOC Raid.tga" },
    ["Heroic The Ruby Sanctum - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Raids - 10", InstanceID = 724, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3520, Icon = "RS.tga" },
    ["Heroic Icecrown Citadel - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Raids - 10", InstanceID = 631, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3510, Icon = "ICC.tga" },
    ["Heroic Trial of the Grand Crusader - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Raids - 10", InstanceID = 649, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3500, Icon = "TOC Raid.tga" },
    ["The Ruby Sanctum - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 724, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3490, Icon = "RS.tga" },
    ["Icecrown Citadel - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 631, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3480, Icon = "ICC.tga" },
    ["Trial of the Crusader - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 649, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3470, Icon = "TOC Raid.tga" },
    ["Ulduar - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 603, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3460, Icon = "ULD.tga" },
    ["Onyxia's Lair - 25"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 249, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3450, Icon = "ONY.tga" },
    ["The Eye of Eternity - 25"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 616, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3440, Icon = "EOE.tga" },
    ["Naxxramas - 25"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 533, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3430, Icon = "NAX.tga" },
    ["The Obsidian Sanctum - 25"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 615, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3420, Icon = "OS.tga" },
    ["Vault of Archavon - 25"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 25", InstanceID = 624, MinLevel = 80, MaxLevel = 80,
        GroupSize = 25, Order = 3410, Icon = "VOA.tga" },
    ["The Ruby Sanctum - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 724, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3400, Icon = "RS.tga" },
    ["Icecrown Citadel - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 631, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3390, Icon = "ICC.tga" },
    ["Trial of the Crusader - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 649, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3380, Icon = "TOC Raid.tga" },
    ["Ulduar - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 603, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3370, Icon = "ULD.tga" },
    ["Onyxia's Lair - 10"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 249, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3360, Icon = "ONY.tga" },
    ["The Eye of Eternity - 10"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 616, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3350, Icon = "EOE.tga" },
    ["The Obsidian Sanctum - 10"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 615, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3340, Icon = "OS.tga" },
    ["Naxxramas - 10"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 533, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3330, Icon = "NAX.tga" },
    ["Vault of Archavon - 10"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Raids - 10", InstanceID = 624, MinLevel = 80, MaxLevel = 80,
        GroupSize = 10, Order = 3320, Icon = "VOA.tga" },
    ["Heroic Ahn'kahet: The Old Kingdom"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 619, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3310, Icon = "OK.tga" },
    ["Heroic Ajzol-Nerub"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 601, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3300, Icon = "AN.tga" },
    ["Heroic Drak'Tharon Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 600, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3290, Icon = "DTK.tga" },
    ["Heroic Gundrak"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 604, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3280, Icon = "GUN.tga" },
    ["Heroic Halls of Lightning"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 602, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3270, Icon = "HOL.tga" },
    ["Heroic Halls of Reflection"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 668, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3260, Icon = "HOR.tga" },
    ["Heroic Halls of Stone"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 599, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3250, Icon = "HOS.tga" },
    ["Heroic Pit of Saron"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 658, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3240, Icon = "PIT.tga" },
    ["Heroic The Culling of Stratholme"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 595, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3230, Icon = "COS.tga" },
    ["Heroic The Forge of Souls"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 632, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3220, Icon = "FOS.tga" },
    ["Heroic The Nexus"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 576, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3210, Icon = "NEX.tga" },
    ["Heroic The Oculus"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 578, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3200, Icon = "OC.tga" },
    ["Heroic The Violet Hold"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 608, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3190, Icon = "VH.tga" },
    ["Heroic Trial of the Champion"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 650, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3180, Icon = "TOC Dungeon.tga" },
    ["Heroic Utgarde Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 574, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3170, Icon = "UK.tga" },
    ["Heroic Utgarde Pinnacle"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Heroic Dungeons", InstanceID = 575, MinLevel = 80, MaxLevel = 85,
        GroupSize = 5, Order = 3160, Icon = "UP.tga" },
    ["Halls of Reflection"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 668, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3150, Icon = "HOR.tga" },
    ["Pit of Saron"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 658, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3140, Icon = "PIT.tga" },
    ["The Forge of Souls"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 632, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3130, Icon = "FOS.tga" },
    ["Trial of the Champion"] = { Active = false, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 650, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3120, Icon = "TOC Dungeon.tga" },
    ["The Oculus"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = 578, MinLevel = 79, MaxLevel = 83, GroupSize = 5, Order = 3110, Icon = "OC.tga" },
    ["Utgarde Pinnacle"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 575, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3100, Icon = "UP.tga" },
    ["Halls of Lightning"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 602, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3090, Icon = "HOL.tga" },
    ["The Culling of Stratholme"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 595, MinLevel = 79, MaxLevel = 83, GroupSize = 5,
        Order = 3080, Icon = "COS.tga" },
    ["Halls of Stone"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 599, MinLevel = 77, MaxLevel = 82, GroupSize = 5,
        Order = 3070, Icon = "HOS.tga" },
    ["Gundrak"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = 604, MinLevel = 76, MaxLevel = 81, GroupSize = 5, Order = 3060, Icon = "GUN.tga" },
    ["The Violet Hold"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 608, MinLevel = 75, MaxLevel = 80, GroupSize = 5,
        Order = 3050, Icon = "VH.tga" },
    ["Drak'Tharon Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 600, MinLevel = 74, MaxLevel = 79, GroupSize = 5,
        Order = 3040, Icon = "DTK.tga" },
    ["Ahn'kahet: The Old Kingdom"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 619, MinLevel = 73, MaxLevel = 78, GroupSize = 5,
        Order = 3030, Icon = "OK.tga" },
    ["Ajzol-Nerub"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = 601, MinLevel = 72, MaxLevel = 77, GroupSize = 5, Order = 3020, Icon = "AN.tga" },
    ["The Nexus"] = { Active = true, Expac = "Wrath of the Lich King", InstanceType = "Wrath of the Lich King Dungeons",
        InstanceID = 576, MinLevel = 70, MaxLevel = 76, GroupSize = 5, Order = 3010, Icon = "NEX.tga" },
    ["Utgarde Keep"] = { Active = true, Expac = "Wrath of the Lich King",
        InstanceType = "Wrath of the Lich King Dungeons", InstanceID = 574, MinLevel = 70, MaxLevel = 75, GroupSize = 5,
        Order = 3000, Icon = "UK.tga" },
    ["Sunwell Plateau"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 580, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2400, Icon = "SWP.tga" },
    ["Black Temple"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 564, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2390, Icon = "BT.tga" },
    ["Hyjal Summit"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 534, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2380, Icon = "MH.tga" },
    ["Tempest Keep"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 550, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2370, Icon = "TK.tga" },
    ["Serpentshrine Cavern"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 548, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2360, Icon = "SSC.tga" },
    ["Magtheridon's Lair"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 544, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2350, Icon = "MAG.tga" },
    ["Gruul's Lair"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 565, MinLevel = 70, MaxLevel = 70, GroupSize = 25, Order = 2340, Icon = "GRUUL.tga" },
    ["Zul'Aman"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 568, MinLevel = 70, MaxLevel = 70, GroupSize = 10, Order = 2330, Icon = "ZA.tga" },
    ["Karazhan"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Raids",
        InstanceID = 532, MinLevel = 70, MaxLevel = 70, GroupSize = 10, Order = 2320, Icon = "KARA.tga" },
    ["Heroic Auchenai Crypts"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 558, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2310, Icon = "AC.tga" },
    ["Heroic Hellfire Ramparts"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 543, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2300, Icon = "RAMPS.tga" },
    ["Heroic Magisters' Terrace"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 585, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2290, Icon = "MGT.tga" },
    ["Heroic Mana-Tombs"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 557, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2280, Icon = "MT.tga" },
    ["Heroic Old Hillsbrad Foothills"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 560, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2270, Icon = "OHB.tga" },
    ["Heroic Sethekk Halls"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 556, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2260, Icon = "SETHEKK.tga" },
    ["Heroic Shadow Labyrinth"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 555, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2250, Icon = "SL.tga" },
    ["Heroic The Arcatraz"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 552, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2240, Icon = "ARC.tga" },
    ["Heroic The Black Morass"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 269, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2230, Icon = "BM.tga" },
    ["Heroic The Blood Furnace"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 542, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2220, Icon = "BF.tga" },
    ["Heroic The Botanica"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 553, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2210, Icon = "BOT.tga" },
    ["Heroic The Mechanar"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 554, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2200, Icon = "MECH.tga" },
    ["Heroic The Shattered Halls"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 540, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2190, Icon = "SH.tga" },
    ["Heroic The Slave Pens"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 547, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2180, Icon = "SP.tga" },
    ["Heroic The Steamvault"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 545, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2170, Icon = "SV.tga" },
    ["Heroic The Underbog"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Heroic Dungeons", InstanceID = 546, MinLevel = 70, MaxLevel = 75,
        GroupSize = 5, Order = 2160, Icon = "UB.tga" },
    ["Magisters' Terrace"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Dungeons", InstanceID = 585, MinLevel = 70, MaxLevel = 75, GroupSize = 5,
        Order = 2150, Icon = "MGT.tga" },
    ["The Black Morass"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 269, MinLevel = 70, MaxLevel = 75, GroupSize = 5, Order = 2140, Icon = "BM.tga" },
    ["The Steamvault"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 545, MinLevel = 70, MaxLevel = 75, GroupSize = 5, Order = 2130, Icon = "SV.tga" },
    ["The Arcatraz"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 552, MinLevel = 69, MaxLevel = 75, GroupSize = 5, Order = 2120, Icon = "ARC.tga" },
    ["The Botanica"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 553, MinLevel = 69, MaxLevel = 75, GroupSize = 5, Order = 2110, Icon = "BOT.tga" },
    ["The Shattered Halls"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Dungeons", InstanceID = 540, MinLevel = 69, MaxLevel = 75, GroupSize = 5,
        Order = 2100, Icon = "SH.tga" },
    ["The Mechanar"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 554, MinLevel = 69, MaxLevel = 75, GroupSize = 5, Order = 2090, Icon = "MECH.tga" },
    ["Shadow Labyrinth"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 555, MinLevel = 69, MaxLevel = 73, GroupSize = 5, Order = 2080, Icon = "SL.tga" },
    ["Sethekk Halls"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 556, MinLevel = 67, MaxLevel = 72, GroupSize = 5, Order = 2070, Icon = "SETHEKK.tga" },
    ["Old Hillsbrad Foothills"] = { Active = true, Expac = "The Burning Crusade",
        InstanceType = "The Burning Crusade Dungeons", InstanceID = 560, MinLevel = 66, MaxLevel = 71, GroupSize = 5,
        Order = 2060, Icon = "OHB.tga" },
    ["Auchenai Crypts"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 558, MinLevel = 65, MaxLevel = 70, GroupSize = 5, Order = 2050, Icon = "AC.tga" },
    ["Mana-Tombs"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 557, MinLevel = 64, MaxLevel = 69, GroupSize = 5, Order = 2040, Icon = "MT.tga" },
    ["The Underbog"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 546, MinLevel = 62, MaxLevel = 68, GroupSize = 5, Order = 2030, Icon = "UB.tga" },
    ["The Slave Pens"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 547, MinLevel = 62, MaxLevel = 67, GroupSize = 5, Order = 2020, Icon = "SP.tga" },
    ["The Blood Furnace"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 542, MinLevel = 61, MaxLevel = 66, GroupSize = 5, Order = 2010, Icon = "BF.tga" },
    ["Hellfire Ramparts"] = { Active = true, Expac = "The Burning Crusade", InstanceType = "The Burning Crusade Dungeons",
        InstanceID = 543, MinLevel = 59, MaxLevel = 65, GroupSize = 5, Order = 2000, Icon = "RAMPS.tga" },
    ["Naxxramas"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = 533,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1360, Icon = "NAX.tga" },
    ["Temple of Ahn'Qiraj"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids",
        InstanceID = 531, MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1350, Icon = "AQ40.tga" },
    ["Blackwing Lair"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = 469,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1340, Icon = "BWL.tga" },
    ["Molten Core"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = 409,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1330, Icon = "MC.tga" },
    ["Onyxia's Lair"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = 249,
        MinLevel = 60, MaxLevel = 60, GroupSize = 40, Order = 1320, Icon = "ONY.tga" },
    ["Ruins of Ahn'Qiraj"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids",
        InstanceID = 509, MinLevel = 60, MaxLevel = 60, GroupSize = 20, Order = 1310, Icon = "AQ20.tga" },
    ["Zul'Gurub"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids", InstanceID = 309,
        MinLevel = 60, MaxLevel = 60, GroupSize = 20, Order = 1300, Icon = "ZG.tga" },
    ["Upper Blackrock Spire"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Raids",
        InstanceID = 229, MinLevel = 60, MaxLevel = 60, GroupSize = 10, Order = 1290, Icon = "UBRS.tga" },
    ["Scholomance"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 1007,
        MinLevel = 57, MaxLevel = 65, GroupSize = 5, Order = 1280, Icon = "SCHOLO.tga" },
    ["Stratholme"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 329,
        MinLevel = 57, MaxLevel = 64, GroupSize = 5, Order = 1270, Icon = "STRAT.tga" },
    ["Dire Maul - Full Clear"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 429, MinLevel = 55, MaxLevel = 62, GroupSize = 5, Order = 1260, Icon = "DM.tga" },
    ["Dire Maul - North Wing"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 429, MinLevel = 58, MaxLevel = 62, GroupSize = 5, Order = 1250, Icon = "DM.tga" },
    ["Dire Maul - West Wing"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 429, MinLevel = 56, MaxLevel = 61, GroupSize = 5, Order = 1240, Icon = "DM.tga" },
    ["Dire Maul - East Wing"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 429, MinLevel = 55, MaxLevel = 61, GroupSize = 5, Order = 1230, Icon = "DM.tga" },
    ["Lower Blackrock Spire"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 229, MinLevel = 54, MaxLevel = 63, GroupSize = 5, Order = 1220, Icon = "LBRS.tga" },
    ["Blackrock Depths"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 230, MinLevel = 52, MaxLevel = 59, GroupSize = 5, Order = 1210, Icon = "BRD.tga" },
    ["The Temple of Atal'Hakkar"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 109, MinLevel = 48, MaxLevel = 53, GroupSize = 5, Order = 1200, Icon = "ST.tga" },
    ["Maraudon - Full Clear"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 349, MinLevel = 42, MaxLevel = 51, GroupSize = 5, Order = 1190, Icon = "MARA.tga" },
    ["Maraudon - Princess"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 349, MinLevel = 46, MaxLevel = 51, GroupSize = 5, Order = 1180, Icon = "MARA.tga" },
    ["Maraudon - Orange"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 349, MinLevel = 44, MaxLevel = 49, GroupSize = 5, Order = 1170, Icon = "MARA.tga" },
    ["Maraudon - Purple"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 349, MinLevel = 42, MaxLevel = 47, GroupSize = 5, Order = 1160, Icon = "MARA.tga" },
    ["Zul'Farrak"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 209,
        MinLevel = 43, MaxLevel = 49, GroupSize = 5, Order = 1150, Icon = "ZF.tga" },
    ["Uldaman"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 70,
        MinLevel = 36, MaxLevel = 43, GroupSize = 5, Order = 1140, Icon = "ULDA.tga" },
    ["Razorfen Downs"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 129, MinLevel = 35, MaxLevel = 44, GroupSize = 5, Order = 1130, Icon = "RFD.tga" },
    ["Scarlet Monastery - Full Clear"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 1004, MinLevel = 30, MaxLevel = 43, GroupSize = 5, Order = 1120, Icon = "SM.tga" },
    ["Scarlet Monastery - Cathedral"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 1004, MinLevel = 37, MaxLevel = 43, GroupSize = 5, Order = 1110, Icon = "SM.tga" },
    ["Scarlet Monastery - Armory"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 1004, MinLevel = 35, MaxLevel = 40, GroupSize = 5, Order = 1100, Icon = "SM.tga" },
    ["Scarlet Monastery - Library"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 1004, MinLevel = 33, MaxLevel = 38, GroupSize = 5, Order = 1090, Icon = "SM.tga" },
    ["Scarlet Monastery - Graveyard"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 1004, MinLevel = 30, MaxLevel = 35, GroupSize = 5, Order = 1080, Icon = "SM.tga" },
    ["Gnomeregan"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 90,
        MinLevel = 25, MaxLevel = 31, GroupSize = 5, Order = 1070, Icon = "GNOMER.tga" },
    ["Razorfen Kraul"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 47,
        MinLevel = 24, MaxLevel = 30, GroupSize = 5, Order = 1060, Icon = "RFK.tga" },
    ["The Stockade"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 34,
        MinLevel = 23, MaxLevel = 28, GroupSize = 5, Order = 1050, Icon = "STOCKS.tga" },
    ["Blackfathom Deeps"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 48, MinLevel = 23, MaxLevel = 27, GroupSize = 5, Order = 1040, Icon = "BFD.tga" },
    ["Shadowfang Keep"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 33, MinLevel = 18, MaxLevel = 24, GroupSize = 5, Order = 1030, Icon = "SFK.tga" },
    ["Wailing Caverns"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 43, MinLevel = 17, MaxLevel = 25, GroupSize = 5, Order = 1020, Icon = "WC.tga" },
    ["The Deadmines"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons", InstanceID = 36,
        MinLevel = 14, MaxLevel = 23, GroupSize = 5, Order = 1010, Icon = "VC.tga" },
    ["Ragefire Chasm"] = { Active = true, Expac = "World of Warcraft", InstanceType = "Classic Dungeons",
        InstanceID = 389, MinLevel = 13, MaxLevel = 19, GroupSize = 5, Order = 1000, Icon = "RFC.tga" },
}

--For use in generating config controls, get all instance orders in order
addon.instanceOrders = {}
addon.instanceConfigData = {}
for key, val in pairs(addon.groupieInstanceData) do
    tinsert(addon.instanceOrders, val.Order)
    addon.instanceConfigData[val.Order] = {
        Name = key,
        InstanceType = val.InstanceType,
        MinLevel = val.MinLevel,
        MaxLevel = val.MaxLevel,
        GroupSize = val.GroupSize,
        IsHeroic = false
    }
    if strmatch(addon.instanceConfigData[val.Order].Name, "Heroic") then
        addon.instanceConfigData[val.Order].IsHeroic = true
    end
end
sort(addon.instanceOrders, function(a, b) return a > b end)

addon.groupieUnflippedDungeonPatterns = {
    ["Ragefire Chasm"]                 = "rfc ragefire chasm",
    ["Wailing Caverns"]                = "wc wailing caverns",
    ["The Deadmines"]                  = "deadmines vc vancleef dead mines mine",
    ["Shadowfang Keep"]                = "sfk shadowfang",
    ["The Stockade"]                   = "stk stock stockade stockades",
    ["Blackfathom Deeps"]              = "bfd blackfathom fathom",
    ["Gnomeregan"]                     = "gnomer gnomeregan",
    ["Razorfen Kraul"]                 = "rfk kraul",
    ["Scarlet Monastery - Full Clear"] = "sm scarlet monastery",
    ["Scarlet Monastery - Graveyard"]  = "smgy smg gy graveyard",
    ["Scarlet Monastery - Library"]    = "smlib sml lib library",
    ["Scarlet Monastery - Armory"]     = "smarm sma arm armory herod armoury arms",
    ["Scarlet Monastery - Cathedral"]  = "smcath smc cath cathedral",
    ["Razorfen Downs"]                 = "rfd downs",
    ["Uldaman"]                        = "ulda uldaman",
    ["Zul'Farrak"]                     = "zf zulfarrak farrak",
    ["Maraudon - Full Clear"]          = "mara maraudon",
    ["Maraudon - Princess"]            = "princessrun princess",
    ["Maraudon - Purple"]              = "purple",
    ["Maraudon - Orange"]              = "orange",
    ["The Temple of Atal'Hakkar"]      = "st sunken atal temple",
    ["Blackrock Depths"]               = "brd emperor arena emp",
    ["Dire Maul - Full Clear"]         = "dm dire maul diremaul",
    ["Dire Maul - East Wing"]          = "dme dmeast east puzilin jumprun",
    ["Dire Maul - North Wing"]         = "dmn dmnorth north tribute",
    ["Dire Maul - West Wing"]          = "dmw dmwest west",
    ["Lower Blackrock Spire"]          = "lower lbrs lrbs",
    ["Stratholme"]                     = "stratlive live living stratUD undead ud baron stratholme stath stratholm strah strath strat starth",
    ["Scholomance"]                    = "scholomance scholo sholo sholomance",

    ["Upper Blackrock Spire"] = "upper ubrs urbs rend",
    ["Zul'Gurub"]             = "zg gurub zulgurub",
    ["Ruins of Ahn'Qiraj"]    = "ruins aq20",
    ["Onyxia's Lair"]         = "onyxia ony",
    ["Molten Core"]           = "molten mc",
    ["Blackwing Lair"]        = "blackwing bwl",
    ["Temple of Ahn'Qiraj"]   = "aq40",
    ["Naxxramas"]             = "naxxramas nax naxx",

    ["Hellfire Ramparts"]       = "ramparts rampart ramp ramps",
    ["The Blood Furnace"]       = "furnace furn bf",
    ["The Slave Pens"]          = "slavepens pens sp",
    ["The Underbog"]            = "underbog ub",
    ["Mana-Tombs"]              = "manatombs manatomb mana mt tomb tombs",
    ["Auchenai Crypts"]         = "crypts crypt auchenai ac acrypts acrypt",
    ["Sethekk Halls"]           = "sethekk seth anzu sethek",
    ["Old Hillsbrad Foothills"] = "ohb durnholde",
    ["Shadow Labyrinth"]        = "sl slab labs labyrinth slabs",
    ["The Mechanar"]            = "mech mechanar",
    ["The Shattered Halls"]     = "sh shh shattered",
    ["The Steamvault"]          = "sv steamvault steamvaults steam valts",
    ["The Botanica"]            = "botanica bot",
    ["The Arcatraz"]            = "arc arcatraz alcatraz",
    ["The Black Morass"]        = "bm morass",
    ["Magisters' Terrace"]      = "mgt terrace magisters magister",

    ["Karazhan"]             = "kara karazhan karazan",
    ["Zul'Aman"]             = "za zulaman aman hsh", --hexshrunken head
    ["Gruul's Lair"]         = "gl gruul gruuls",
    ["Magtheridon's Lair"]   = "mag magtheridon magth",
    ["Serpentshrine Cavern"] = "ssc serpentshrine",
    ["Tempest Keep"]         = "tk tempest tempestkeep",
    ["Hyjal Summit"]         = "hyjal hs hyj mh",
    ["Black Temple"]         = "bt blacktemple glaive",
    ["Sunwell Plateau"]      = "swp sunwell plateau plataeu sunwel",

    ["Utgarde Keep"]               = "uk utgardekeep",
    ["The Nexus"]                  = "nexus",
    ["Ajzol-Nerub"]                = "an azjol nerub",
    ["Ahn'kahet: The Old Kingdom"] = "ok atok ahnkahet ankahet kahet",
    ["Drak'Tharon Keep"]           = "dtk tharon dk",
    ["The Violet Hold"]            = "vh violet violethold",
    ["Gundrak"]                    = "gundrak",
    ["Halls of Stone"]             = "hos stone",
    ["The Culling of Stratholme"]  = "cos culling bronze",
    ["Halls of Lightning"]         = "hol lightning",
    ["Utgarde Pinnacle"]           = "up pinnacle",
    ["The Oculus"]                 = "oculus occulus oc occ",
    --["Trial of the Champion"]      = "",
    ["The Forge of Souls"]         = "forge fos forgeofsouls",
    ["Pit of Saron"]               = "pit pos pitofsaron",
    ["Halls of Reflection"]        = "hor reflection",

    --["Naxxramas"]            = "",
    ["The Obsidian Sanctum"] = "os obsidian obssanc obsanc obsidiansanctum",
    ["Vault of Archavon"]    = "voa archavon vault",
    ["The Eye of Eternity"]  = "eoe eye",
    --["Onyxia's Lair"]        = "",
    ["Ulduar"]               = "uld uldu ulduar",

    ["TOC-SPECIALCASE"]             = "toc trial",
    ["Icecrown Citadel"]            = "icc",
    ["The Ruby Sanctum"]            = "rs rubysanctum rubysanc ruby",
    ["Trial of the Grand Crusader"] = "togc grand",

    ["PVP"] = "2s 3s 5s ab alterac arena av basin challenger conquest cta duelist eots fta fth glad gladiator gulch gurubashi ioc premade PVP rival sota storm strand warsong wg wintergrasp wsg",
}


addon.groupieInstancePatterns = addon.TableFlip(addon.groupieUnflippedDungeonPatterns)
addon.groupieLootPatterns = addon.TableFlip(addon.groupieUnflippedLootPatterns)
addon.groupieLanguagePatterns = addon.TableFlip(addon.groupieUnflippedLanguagePatterns)
